View Issue Details

IDProjectCategoryView StatusLast Update
0001718Far ManagerEditorpublic2011-03-29 13:23
ReporterDenisAssigned Tovskirdin 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Platformx86OSWindowsOS Version7
Product Version2.0 
Target VersionFixed in Version3.0 
Summary0001718: Отсутвие ECF_TAB1 не всегда корректно отрабатывает
DescriptionОтсутвие ECF_TAB1 не всегда корректно отрабатывает.
Steps To Reproducehttp://forum.farmanager.com/viewtopic.php?p=71519#p71519
http://forum.farmanager.com/viewtopic.php?p=78142#p78142
TagsNo tags attached.
Build1936

Activities

vskirdin

2011-03-28 14:09

administrator   bugnote:0006589

Мля... какие-же все "несловоблудно-краткие".
Инц не о чем
Предлагается перечитать туеву хучу обсуждения, чтобы понять смысл бага. А написать сюда суть - видимо не судьба. :-(
Когда мысль сформируется - приходите, подробным описанием.
А пока в морг такой багрепорт.

Denis

2011-03-28 15:53

reporter   bugnote:0006595

Первое приближение описания бага:

Требуется Far2 1807 x86, плагин EdtFindW.v8.rar http://code.google.com/p/far-plugins/downloads/detail?name=EdtFindW.v8.rar&can=2&q=

Открываем в редакторе test2.txt из test2.txt.7z
F11 -> Editor Find -> Options -> включаем Mark whole Tab
затем F11 -> Editor Find -> Find
в строке поиска вводим "M\t"
выбираем опцию "Regular expressions", затем жмём "Entire text".
В редакторе посвечивается только первый символ таба вместо всех (например, у меня - 8ми)

Denis

2011-03-28 15:53

reporter  

test2.txt.7z (158 bytes)

Denis

2011-03-28 15:56

reporter  

1718.png (4,189 bytes)
1718.png (4,189 bytes)

vskirdin

2011-03-28 15:58

administrator   bugnote:0006596

1. В настройках редактора "Expand tabs:" в каком состоянии?
2. Если в редакторе нажать Alt-Shift-F9 и отметить "[x] Show white space" - табы выглядят табами или...?

Denis

2011-03-28 15:58

reporter   bugnote:0006597

Ещё с форума:
Если искать "\t" - то работает. А если "M\t" - не работает.

Denis

2011-03-28 16:00

reporter   bugnote:0006598

[ ] Show white space

Табы выглядят пробелами.

Expand newly entered tabs to spaces.

Denis

2011-03-28 16:01

reporter   bugnote:0006600

Вот кусок из Alt-Shift-F9:

Expand tabs:
Expand newly entered tabs to spaces
[ ] Persistent blocks
[x] Save file position
[x] Auto indent
8 Tab size
[ ] Show white space

max rusov

2011-03-28 16:03

reporter   bugnote:0006601

Попробую описать подробнее, раз это касается моего плагина.
Допустим, в тексте есть строка:

a<tab>b

<tab> - это символ табуляции. Плагин красит эту строку без опции ECF_TAB1. Наблюдается различное поведение в 2-х ситуациях:

1. Если красится 1 символ со 2-ой позиции (т.е. один символ табуляции), то раскраска заполняет все позиции табуляции, что соответствует документации

2. Если красятся 2 символа с первой позиции (т.е.: a<tab> ), то раскраска _не_ заполняет все позиции табуляции, т.е. ведет себя как будто опция ECF_TAB1 включена

Проблема воспроизводится на плагине EdtFind при включении опций:

[ ] Select Found
[x] Show All Matches
[x] Mark whole Tab

Denis

2011-03-28 16:03

reporter  

EdtFind.reg.7z (514 bytes)

Denis

2011-03-28 16:04

reporter   bugnote:0006602

Добавил свои настройки EdtFind.reg.7z

vskirdin

2011-03-28 18:23

administrator   bugnote:0006603

пробуем тест (на основе сорцов 1807)
edit.cpp, Edit::ApplyColor()
ищим строку "// Для отптимизации делаем вычисление относительно предыдущей позиции (с учётом", перед else.
блок else заменяем на
        {
            if (CorrectPos && EndPos < StrSize && Str[EndPos] == L'\t')
                RealEnd = RealPosToTab(TabPos, Pos, ++EndPos, nullptr);
            else
            {
                RealEnd = RealPosToTab(TabPos, Pos, EndPos, &CorrectPos);
                EndPos += CorrectPos;
            }
            End = RealEnd-LeftPos;
        }

Denis

2011-03-28 18:43

reporter   bugnote:0006605

Вроде работает. Спасибо!

vskirdin

2011-03-28 18:47

administrator   bugnote:0006606

совместно с колорером бы проверить :-)

vskirdin

2011-03-28 19:16

administrator   bugnote:0006607

build 1936

sonar

2011-03-28 20:45

reporter   bugnote:0006613

проверяйте.
http://dobrih.net/colorer.7z
сам колорер табы красит только в режиме креста вроде. больше припомнить не могу где еще

Issue History

Date Modified Username Field Change
2011-02-21 11:02 Denis New Issue
2011-03-28 14:09 vskirdin Build => -1
2011-03-28 14:09 vskirdin Note Added: 0006589
2011-03-28 14:09 vskirdin Status new => closed
2011-03-28 14:09 vskirdin Assigned To => vskirdin
2011-03-28 14:09 vskirdin Resolution open => fixed
2011-03-28 15:43 Denis Status closed => feedback
2011-03-28 15:43 Denis Resolution fixed => reopened
2011-03-28 15:53 Denis Note Added: 0006595
2011-03-28 15:53 Denis Status feedback => assigned
2011-03-28 15:53 Denis File Added: test2.txt.7z
2011-03-28 15:56 Denis File Added: 1718.png
2011-03-28 15:58 vskirdin Note Added: 0006596
2011-03-28 15:58 Denis Note Added: 0006597
2011-03-28 16:00 Denis Note Added: 0006598
2011-03-28 16:01 Denis Note Added: 0006600
2011-03-28 16:03 max rusov Note Added: 0006601
2011-03-28 16:03 Denis File Added: EdtFind.reg.7z
2011-03-28 16:04 Denis Note Added: 0006602
2011-03-28 18:23 vskirdin Note Added: 0006603
2011-03-28 18:43 Denis Note Added: 0006605
2011-03-28 18:47 vskirdin Note Added: 0006606
2011-03-28 19:16 vskirdin Note Added: 0006607
2011-03-28 19:16 vskirdin Status assigned => feedback
2011-03-28 20:45 sonar Note Added: 0006613
2011-03-29 12:12 Denis Status feedback => resolved
2011-03-29 13:23 vskirdin Build -1 => 1936
2011-03-29 13:23 vskirdin Status resolved => closed
2011-03-29 13:23 vskirdin Resolution reopened => fixed
2011-03-29 13:23 vskirdin Fixed in Version => 3.0